#include "LLP_Support.h"

//static char *s_InputText = "Gene[NameQ\"TG\"]{GeneHeader{Seq{IRand, LongConst[7], LongConst[7, 3]}}}";
static char *s_InputText = "Gene[NameQ\"TG\"]{}";
//                         0123456789
static int s_iTextCursor = 0;


extern "C" {
	
	// Do nothing, as we report the real error messages through our own mechanism...
	void LLPerror(const char *message) {
		fprintf(stderr, "\nYYERROR: %s\n", message);
	}


	int LLP_GetMoreChars(char *buffer, int max_chars) {
		if (s_InputText[s_iTextCursor] != '\0') {
			*buffer = s_InputText[s_iTextCursor];

			s_iTextCursor++;

			return 1;
		}

		return 0;
	}

	void LLP_SetErrorMessage(const char *message, YYLTYPE loc) {
		fprintf(stderr, "\nERROR MESSAGE: %s - %i - %i\n", message, loc.first_column, loc.last_column);
	}
}

extern "C" { extern int LLPdebug; }

int main() {
	LLPdebug = 1;
	LLPparse();

	return 0;
}
